## galera-4 26.4.20

=== SConstruct ===
###################################################################
#
# Copyright (C) 2010-2020 Codership Oy <info@codership.com>
#
# SCons build script to build galera libraries
#
# How to control the build with environment variables:
# Set CC       to specify C compiler
# Set CXX      to specify C++ compiler
# Set CPPFLAGS to add non-standard include paths and preprocessor macros
# Set CCFLAGS  to *override* optimization and architecture-specific options
# Set CFLAGS   to supply C compiler options
# Set CXXFLAGS to supply C++ compiler options
# Set LDFLAGS  to *override* linking flags
# Set LIBPATH  to add non-standard linker paths
# Set RPATH    to add rpaths
#
# Some useful CPPFLAGS:
# GCS_SM_DEBUG          - enable dumping of send monitor state and history
# GU_DEBUG_MUTEX        - enable mutex debug instrumentation
# GU_DBUG_ON            - enable sync point macros
#
# Script structure:
# - Help message
# - Default parameters
# - Read commandline options
# - Set up and configure default build environment
# - Set up and configure check unit test build environment
# - Run root SConscript with variant_dir
#
####################################################################

import os
import platform
import string
import subprocess

# Execute a command and read the first line of its stdout.
# For example read_first_line(["ls", "-l", "/usr"])
def read_first_line(cmd):
    p = subprocess.Popen(cmd, stdout=subprocess.PIPE)
    stdout = p.communicate()[0]
    line = stdout.splitlines()[0]
    return line

sysname = os.uname()[0].lower()
machine = platform.machine()
bits = ARGUMENTS.get('bits', platform.architecture()[0])
print('Host: ' + sysname + ' ' + machine + ' ' + bits)

x86 = any(arch in machine for arch in [ 'x86', 'amd64', 'i686', 'i386', 'i86pc' ])

if bits == '32bit':
    bits = 32
elif bits == '64bit':
    bits = 64

#
# Print Help
#

Help('''
Build targets:  build tests check install all
Default target: all

Commandline Options:
    debug=n             debug build with optimization level n
    asan=[0|1]          disable or enable ASAN instrumentation
    build_dir=dir       build directory, default: '.'
    boost=[0|1]         disable or enable boost libraries
    system_asio=[0|1]   use system asio library, if available
    asio_path=path      path to asio headers
    boost_pool=[0|1]    use or not use boost pool allocator
    revno=XXXX          source code revision number
    bpostatic=path      a path to static libboost_program_options.a
    ssl=[0|1]           build without/with SSL enabled
    static_ssl=path     a path to static SSL libraries
    extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
    bits=[32bit|64bit]
    gcov=[True|False]   compile Galera for code coverage reporting
    install=path        install files under path
    version_script=[0|1] Use version script (default 1)
    crc32c_no_hardware=[0|1] disable building hardware support for CRC32C
''')
# bpostatic option added on Percona request

#
# Default params
#

build_target = 'all'

# Optimization level
opt_flags    = ' -g -O3 -DNDEBUG'

# Architecture (defaults to build host type)
compile_arch = ''
link_arch    = ''

# Build directory
build_dir    = ''

# Version script file
galera_script = File('#/galera/src/galera-sym.map').abspath

#
# Read commandline options
#

build_dir = ARGUMENTS.get('build_dir', '')

# Debug/dbug flags
debug = ARGUMENTS.get('debug', -1)
dbug  = ARGUMENTS.get('dbug', False)
asan = ARGUMENTS.get('asan', 0)
gcov = ARGUMENTS.get('gcov', False)

debug_lvl = int(debug)
if debug_lvl >= 0 and debug_lvl < 3:
    opt_flags = ' -g -O%d -fno-inline' % debug_lvl
    dbug = True
elif debug_lvl == 3:
    opt_flags = ' -g -O3'

if dbug:
    opt_flags = opt_flags + ' -DGU_DBUG_ON'

if gcov:
    opt_flags = opt_flags + ' --coverage -g'

if sysname == 'sunos':
    compile_arch = ' -mtune=native'
elif x86:
    if bits == 32:
        if machine == 'x86_64':
            compile_arch = ' -mx32'
        else:
            compile_arch = ' -m32 -march=i686'
            if sysname == 'linux':
                link_arch = ' -Wl,-melf_i386'
    else:
        compile_arch = ' -m64'
        if sysname == 'linux':
            link_arch = ' -Wl,-melf_x86_64'
    link_arch = compile_arch + link_arch
elif machine == 's390x':
    compile_arch = ' -mzarch'
    if bits == 32:
        compile_arch += ' -m32'

boost      = int(ARGUMENTS.get('boost', 1))
boost_pool = int(ARGUMENTS.get('boost_pool', 0))
system_asio= int(ARGUMENTS.get('system_asio', 1))
asio_path  = ARGUMENTS.get('asio_path')
tests      = int(ARGUMENTS.get('tests', 1))
# Run only tests which are known to be deterministic
deterministic_tests = int(ARGUMENTS.get('deterministic_tests', 0))
# Run all tests
all_tests = int(ARGUMENTS.get('all_tests', 0))
strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
have_ssl = int(ARGUMENTS.get('ssl', 1))
static_ssl = ARGUMENTS.get('static_ssl', None)
install = ARGUMENTS.get('install', None)
version_script = int(ARGUMENTS.get('version_script', 1))

GALERA_VER = ARGUMENTS.get('version', '4.20')
GALERA_REV = ARGUMENTS.get('revno', 'XXXX')

# Attempt to read from file if not given
if GALERA_REV == "XXXX" and os.path.isfile("GALERA_REVISION"):
    with open("GALERA_REVISION", "r") as f:
        GALERA_REV = f.readline().rstrip("\n")

# export to any module that might have use of those
Export('GALERA_VER', 'GALERA_REV')
print('Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV)

LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '')
LIBBOOST_SYSTEM_A = LIBBOOST_PROGRAM_OPTIONS_A.replace('boost_program_options', 'boost_system')

#
# Set up and export default build environment
#

env = Environment(ENV = {'PATH' : os.environ['PATH'], 'HOME' : os.environ['HOME']})

# Set up environment for ccache and distcc
#env['ENV']['HOME']          = os.environ['HOME']
#env['ENV']['DISTCC_HOSTS']  = os.environ['DISTCC_HOSTS']
#env['ENV']['CCACHE_PREFIX'] = os.environ['CCACHE_PREFIX']
if 'CCACHE_DIR' in os.environ:
    env['ENV']['CCACHE_DIR'] = os.environ['CCACHE_DIR']
if 'CCACHE_CPP2' in os.environ:
    env['ENV']['CCACHE_CPP2'] = os.environ['CCACHE_CPP2']

# Set CC and CXX compilers
cc = os.getenv('CC', 'default')
if cc != 'default':
    env.Replace(CC = cc)
cxx = os.getenv('CXX', 'default')
if cxx != 'default':
    env.Replace(CXX = cxx)
link = os.getenv('LINK', 'default')
if link != 'default':
    env.Replace(LINK = link)

# Get compiler name/version, CXX may be set to "c++" which may be clang or gcc
cc_version = str(read_first_line(env['CC'].split() + ['--version']))
cxx_version = str(read_first_line(env['CXX'].split() + ['--version']))

print('Using C compiler executable: ' + env['CC'])
print('C compiler version is: ' + cc_version)
print('Using C++ compiler executable: ' + env['CXX'])
print('C++ compiler version is: ' + cxx_version)

# Initialize CPPFLAGS and LIBPATH from environment to get user preferences
env.Replace(CPPFLAGS  = os.getenv('CPPFLAGS', ''))
env.Replace(CCFLAGS   = os.getenv('CCFLAGS',  opt_flags + compile_arch))
env.Replace(CFLAGS    = os.getenv('CFLAGS',   ''))
env.Replace(CXXFLAGS  = os.getenv('CXXFLAGS', ''))
env.Replace(LINKFLAGS = os.getenv('LDFLAGS',  link_arch))
env.Replace(LIBPATH   = [os.getenv('LIBPATH', '')])
env.Replace(RPATH     = [os.getenv('RPATH',   '')])

# Set -pthread flag explicitly to make sure that pthreads are
# enabled on all platforms.
env.Append(CCFLAGS = ' -pthread')

# FreeBSD ports are usually installed under /usr/local
if sysname == 'freebsd' or sysname == 'sunos':
    env.Append(LIBPATH = ['/usr/local/lib'])
    env.Append(CPPPATH = ['/usr/local/include'])
if sysname == 'sunos':
   env.Replace(SHLINKFLAGS = '-shared ')

# Add paths is extra_sysroot argument was specified
extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
if sysname == 'darwin' and extra_sysroot == '':
    # common developer environments and paths
    if os.system('which -s port') == 0 and os.path.isfile('/opt/local/bin/port'):
        extra_sysroot = '/opt/local'
    elif os.system('which -s brew') == 0 and os.path.isfile('/usr/local/bin/brew'):
        extra_sysroot = '/usr/local'
    elif os.system('which -s fink') == 0 and os.path.isfile('/sw/bin/fink'):
        extra_sysroot = '/sw'
if extra_sysroot != '':
    env.Append(LIBPATH = [extra_sysroot + '/lib'])
    env.Append(CPPFLAGS = ' -I' + extra_sysroot + '/include')

# print env.Dump()

# Preprocessor flags
if sysname != 'sunos' and sysname != 'darwin' and sysname != 'freebsd':
    env.Append(CPPFLAGS = ' -D_XOPEN_SOURCE=600')
if sysname == 'sunos':
    env.Append(CPPFLAGS = ' -D__EXTENSIONS__')
env.Append(CPPFLAGS = ' -DHAVE_COMMON_H')

# Common C/CXX flags
# These should be kept minimal as they are appended after C/CXX specific flags
env.Append(CCFLAGS = ' -fPIC -Wall -Wextra -Wno-unused-parameter')

# C-specific flags
env.Prepend(CFLAGS = '-std=c99 -fno-strict-aliasing -pipe ')

# CXX-specific flags
# Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
#       adding those after checks
env.Prepend(CXXFLAGS = '-Wno-long-long -Wno-deprecated ')
if sysname != 'sunos':
    env.Prepend(CXXFLAGS = '-pipe ')


# Linker flags
# TODO: enable ' -Wl,--warn-common -Wl,--fatal-warnings' after warnings from
# static linking have beed addressed
#
#env.Prepend(LINKFLAGS = '-Wl,--warn-common -Wl,--fatal-warnings ')
if int(asan):
    env.Append(CCFLAGS = ' -fsanitize=address')
    env.Append(CPPFLAGS = ' -DGALERA_WITH_ASAN')
    env.Append(LINKFLAGS = ' -fsanitize=address')

if gcov:
    env.Append(LINKFLAGS = ' --coverage -g')

#
# Check required headers and libraries (autoconf functionality)
#

#
# Custom tests:
#

def CheckCpp0x(context):
    test_source = """
int main() { return 0; }
"""
    context.Message('Checking if compiler accepts -std=c++0x ... ')
    cxxflags_orig = context.env['CXXFLAGS']
    context.env.Prepend(CXXFLAGS = '-std=c++0x ')
    result = context.TryLink(test_source, '.cpp')
    context.env.Replace(CXXFLAGS = cxxflags_orig)
    context.Result(result)
    return result

def CheckCpp11(context):
    test_source = """
int main() { return 0; }
"""
    context.Message('Checking if compiler accepts -std=c++11 ... ')
    cxxflags_orig = context.env['CXXFLAGS']
    context.env.Prepend(CXXFLAGS = '-std=c++11 ')
    result = context.TryLink(test_source, '.cpp')
    context.env.Replace(CXXFLAGS = cxxflags_orig)
    context.Result(result)
    return result

def CheckSystemASIOVersion(context):
    system_asio_test_source_file = """
#include <asio.hpp>

#define XSTR(x) STR(x)
#define STR(x) #x
#pragma message "Asio version:" XSTR(ASIO_VERSION)
#if ASIO_VERSION < 101008
#error Included asio version is too old
#elif ASIO_VERSION >= 101100
#error Included asio version is too new
#endif

int main()
{
    return 0;
}

"""
    context.Message('Checking ASIO version (>= 1.10.8 and < 1.11.0) ... ')
    result = context.TryLink(system_asio_test_source_file, '.cpp')
    context.Result(result)
    return result

def CheckTr1Array(context):
    test_source = """
#include <tr1/array>
int main() { std::tr1::array<int, 5> a; return 0; }
"""
    context.Message('Checking for std::tr1::array ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckStdSharedPtr(context):
    test_source = """
#include <memory>
int main() { int n; std::shared_ptr<int> p(&n); return 0; }
"""
    context.Message('Checking for std::shared_ptr ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckTr1UnorderedMap(context):
    test_source = """
#include <tr1/unordered_map>
int main() { std::tr1::unordered_map<int, int> m; return 0; }
"""
    context.Message('Checking for std::tr1::unordered_map ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckWeffcpp(context):

=== debian/changelog ===
galera-4 (26.4.20-1) unstable; urgency=medium

  * New upstream release 26.4.20. Includes multiple bug fixes, see
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.20.txt
  * Extend gbp.conf and write a README.source to document new upstream import
  * Update debian/patches to be compatible with `gbp pq` which is easier
    for contributors to use, and to avoid cumbersome `quilt`

 -- Otto Kekäläinen <otto@debian.org>  Tue, 03 Sep 2024 07:47:17 -0700

=== debian/control ===
Source: galera-4
Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders:
 Otto Kekäläinen <otto@debian.org>,
Section: database
Priority: optional
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 check,
 cmake,
 debhelper-compat (= 12),
 libboost-dev,
 libboost-program-options-dev,
 libssl-dev,
Homepage: https://www.galeracluster.com/
Vcs-Browser: https://salsa.debian.org/mariadb-team/galera-4
Vcs-Git: https://salsa.debian.org/mariadb-team/galera-4.git

Package: galera-4
Architecture: any
Section: libs
Pre-Depends:
 adduser,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 garbd-2,
 garbd-3,
 garbd2,
 garbd3,
 percona-galera-3,
 percona-galera-4,
 percona-xtradb-cluster-galera,
 percona-xtradb-cluster-galera-2.x,
 percona-xtradb-cluster-galera-3.x,
 percona-xtradb-cluster-galera-4.x,
 percona-xtradb-cluster-garbd-2.x,
 percona-xtradb-cluster-garbd-3.x,
Provides:
 galera4,
 percona-xtradb-cluster-galera-26,
 wsrep,
Breaks:
 galera-3 (<< 26.4),
Replaces:
 galera-3 (<< 26.4),
Description: Replication framework for transactional applications
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see https://github.com/codership/wsrep-API. For a description
 of Galera replication engine see http://galeracluster.com.
 .
 This package contains the Galera library/plugin.

Package: galera-arbitrator-4
Architecture: any
Conflicts:
 galera-arbitrator-3,
 garbd-2,
 garbd2,
 percona-galera-arbitrator-3,
 percona-galera-arbitrator-4,
 percona-xtradb-cluster-garbd-2.x,
Breaks:
 percona-xtradb-cluster-galera-2.x,
Replaces:
 percona-xtradb-cluster-galera-2.x,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Galera arbitrator daemon
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see https://github.com/codership/wsrep-API. For a description
 of Galera replication engine see http://galeracluster.com.
 .
 This package contains the Galera arbitrator daemon (garbd).

=== debian/tests/control ===
Tests: smoke
Depends:
 galera-arbitrator-4,
Restrictions: allow-stderr superficial

## galera-4 26.4.21

=== CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

message(STATUS "CMake version ${CMAKE_VERSION}")
cmake_minimum_required(VERSION 2.8)
project(galera-4)

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckCXXCompilerFlag)
include(CheckLibraryExists)

include_directories(
  ${PROJECT_SOURCE_DIR}
  ${PROJECT_SOURCE_DIR}/common
  ${PROJECT_SOURCE_DIR}/galera/src
  ${PROJECT_SOURCE_DIR}/galerautils/src
  ${PROJECT_SOURCE_DIR}/gcache/src
  ${PROJECT_SOURCE_DIR}/gcomm/src
  ${PROJECT_SOURCE_DIR}/gcs/src
  ${PROJECT_SOURCE_DIR}/wsrep/src
  )

# Options to control compiler options and error behavior.
option(GALERA_MAINTAINER_MODE "Fail compilation on warnings" OFF)

# Galera library options.
option(GALERA_WITH_SSL "Compile Galera with SSL" ON)
option(GALERA_VERSION_SCRIPT "Limit symbols visible from Galera DSO" ON)
option(GALERA_STATIC "Build statically linked binaries" OFF)
option(GALERA_SOURCE
  "Configure for source package only, skipping build configuration" OFF)

# Developer options and instrumentation.
option(GALERA_WITH_ASAN "Enable ASAN instrumentation" OFF)
option(GALERA_WITH_VALGRIND "Optionally run tests with valgrind" OFF)
option(GALERA_WITH_COVERAGE "Compile with coverage instrumentation" OFF)
option(GALERA_GCS_SM_DEBUG
  "Enable dumping of send monitor state and history" OFF)
option(GALERA_GU_DEBUG_MUTEX "Enable mutex debug instrumentation" OFF)
option(GALERA_GU_DBUG_ON "Enable sync point macros (ON for Debug builds)" OFF)

#
# Set cmake policies before doing any checks.
#

# In CMake 3.12 and above, the
#
# * ``check_include_file`` macro in the ``CheckIncludeFile`` module, the
# * ``check_include_file_cxx`` macro in the
#   ``CheckIncludeFileCXX`` module, and the
# * ``check_include_files`` macro in the ``CheckIncludeFiles`` module
#
# now prefer to link the check executable to the libraries listed in the
# ``CMAKE_REQUIRED_LIBRARIES`` variable.  This policy provides compatibility
# with projects that have not been updated to expect this behavior.
if (POLICY CMP0075)
  CMAKE_POLICY(SET CMP0075 OLD)
endif()

# Determine version first to have it near the top of build log.
include(cmake/version.cmake)
include(cmake/package.cmake)

# Do not execute other configuration steps if building source only.
if (GALERA_SOURCE)
  return()
endif()

# Source compiler/OS settings first as it sets used C/C++ standards,
# common compiler flags and include/link paths.
include(cmake/compiler.cmake)
include(cmake/alignment.cmake)
include(cmake/os.cmake)
# Instrumentation.
include(cmake/asan.cmake)

# Common definitions for all modues.
include(cmake/common.cmake)

# Libraries, language library features.
include(cmake/ssl.cmake)
include(cmake/asio.cmake)
include(cmake/array.cmake)
include(cmake/custom_boost.cmake)
include(cmake/boost.cmake)
include(cmake/crc32c.cmake)
include(cmake/endian.cmake)
include(cmake/shared_ptr.cmake)
include(cmake/unordered.cmake)
include(cmake/check.cmake)
include(cmake/memorycheck.cmake)
include(cmake/coverage.cmake)
# Keep the maintainer mode as last to avoid feature checks failing
# in compiler warnings.
include(cmake/maintainer_mode.cmake)

include(CTest)
enable_testing()
add_subdirectory(galerautils)
add_subdirectory(gcomm)
add_subdirectory(gcache)
add_subdirectory(gcs)
add_subdirectory(garb)
add_subdirectory(galera)
add_subdirectory(scripts/packages)
add_subdirectory(wsrep/tests)

if (NOT ${CMAKE_SYSTEM_NAME} MATCHES ".*BSD")
  install(FILES
    ${PROJECT_SOURCE_DIR}/AUTHORS
    ${PROJECT_SOURCE_DIR}/COPYING
    ${PROJECT_SOURCE_DIR}/README
    DESTINATION doc)
  install(FILES ${PROJECT_SOURCE_DIR}/asio/LICENSE_1_0.txt
    DESTINATION doc
    RENAME LICENSE.asio)
endif()

message(STATUS "")
message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
get_directory_property(DirDefs COMPILE_DEFINITIONS)
message(STATUS "COMPILE_DEFINITIONS: ${DirDefs}")
message(STATUS "CMAKE_C_FLAGS: ${CMAKE_C_FLAGS}")
message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
message(STATUS "CMAKE_EXE_LINKER_FLAGS: ${CMAKE_EXE_LINKER_FLAGS}")
message(STATUS "GALERA_SYSTEM_LIBS: ${GALERA_SYSTEM_LIBS}")
message(STATUS "GALERA_UNIT_TEST_LIBS: ${GALERA_UNIT_TEST_LIBS}")
message(STATUS "")

=== SConstruct ===
--- 
+++ 
@@ -163,7 +163,7 @@
 install = ARGUMENTS.get('install', None)
 version_script = int(ARGUMENTS.get('version_script', 1))
 
-GALERA_VER = ARGUMENTS.get('version', '4.20')
+GALERA_VER = ARGUMENTS.get('version', '4.21')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given

=== debian/changelog ===
galera-4 (26.4.21-1) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * New upstream release 26.4.21. Includes multiple bug fixes, see
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.21.txt
  * Bump standards version to 4.7.0

  [ Adel Belhouane ]
  * Create user _galera in galera-arbitrator-4 instead of galera-4
    (Closes: #1086726)
  * Package galera-arbitrator-4 has to depend on adduser
  * Fix garbd's -w/WORK_DIR parameter (Closes: #1088076)

 -- Otto Kekäläinen <otto@debian.org>  Sun, 26 Jan 2025 18:33:42 -0800

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,12 @@
  Otto Kekäläinen <otto@debian.org>,
 Section: database
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Build-Depends:
+ debhelper-compat (= 12),
  check,
  cmake,
- debhelper-compat (= 12),
  libboost-dev,
  libboost-program-options-dev,
  libssl-dev,
@@ -67,6 +67,8 @@
  percona-xtradb-cluster-galera-2.x,
 Replaces:
  percona-xtradb-cluster-galera-2.x,
+Pre-Depends:
+ adduser,
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},

## galera-4 26.4.22

=== debian/changelog ===
galera-4 (26.4.22-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 17:05:23 +0200

galera-4 (26.4.22-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Aug 2025 16:54:58 +0200

galera-4 (26.4.22-1) unstable; urgency=medium

  * New upstream release 26.4.21. Includes multiple bug fixes, see
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.22.txt
  * Bump debhelper from old 12 to 13
  * Make file installation compatible with Debhelper 13
  * Bump standards version to 4.7.2

 -- Otto Kekäläinen <otto@debian.org>  Fri, 25 Apr 2025 00:01:33 -0700

## galera-4 26.4.23

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 #
-# Copyright (C) 2020 Codership Oy <info@codership.com>
+# Copyright (C) 2025 Codership Oy <info@codership.com>
 #
 
 message(STATUS "CMake version ${CMAKE_VERSION}")
-cmake_minimum_required(VERSION 2.8)
+cmake_minimum_required(VERSION 2.8...4.0)
 project(galera-4)
 
 include(CheckCCompilerFlag)
@@ -42,6 +42,7 @@
   "Enable dumping of send monitor state and history" OFF)
 option(GALERA_GU_DEBUG_MUTEX "Enable mutex debug instrumentation" OFF)
 option(GALERA_GU_DBUG_ON "Enable sync point macros (ON for Debug builds)" OFF)
+option(GALERA_GLIBCXX_DEBUG "Enable glibc++ debug instrumentation" OFF)
 
 #
 # Set cmake policies before doing any checks.

=== SConstruct ===
--- 
+++ 
@@ -163,7 +163,7 @@
 install = ARGUMENTS.get('install', None)
 version_script = int(ARGUMENTS.get('version_script', 1))
 
-GALERA_VER = ARGUMENTS.get('version', '4.21')
+GALERA_VER = ARGUMENTS.get('version', '4.23')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given

=== galera/tests/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

add_executable(galera_check
  galera_check.cpp
  data_set_check.cpp
  certification_check.cpp
  key_set_check.cpp
  write_set_ng_check.cpp
  trx_handle_check.cpp
  service_thd_check.cpp
  ist_check.cpp
  saved_state_check.cpp
  defaults_check.cpp
  progress_check.cpp
  )

target_include_directories(galera_check
  PRIVATE
  ${PROJECT_SOURCE_DIR}/galera/src
  ${PROJECT_SOURCE_DIR}/wsrep/src
  )

# TODO: Fix.
target_compile_options(galera_check
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

target_link_libraries(galera_check galera_smm_static ${GALERA_UNIT_TEST_LIBS})

add_test(
  NAME galera_check
  COMMAND galera_check
  )

=== galerautils/src/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

# Logging facility is extracted into separate library to break
# circular dependency between crc32c HW and galerautils libraries.
add_library(galerautils_log STATIC
  gu_log.c)
target_compile_options(galerautils_log
  PRIVATE
  -Wno-unused-parameter)

#
# Compile hardware optimized CRC32C code into separate library
# to keep the optimized code isolated.
#
if (GALERA_CRC32C_X86_64)
  set(GALERAUTILS_HW_CRC32C_SOURCES gu_crc32c_x86.c)
elseif (GALERA_CRC32C_ARM64)
  set(GALERAUTILS_HW_CRC32C_SOURCES gu_crc32c_arm64.c)
endif()

if (GALERAUTILS_HW_CRC32C_SOURCES)
  set(GALERAUTILS_HW_CRC32C_LIB galerautils_hw_crc32c)
  add_library(${GALERAUTILS_HW_CRC32C_LIB} STATIC
    ${GALERAUTILS_HW_CRC32C_SOURCES})
  target_compile_options(${GALERAUTILS_HW_CRC32C_LIB}
    PRIVATE
    ${GALERA_CRC32C_COMPILER_FLAG})
  target_link_libraries(${GALERAUTILS_HW_CRC32C_LIB} galerautils_log)
endif()

add_library(galerautils STATIC
  gu_abort.c
  gu_crc32c.c
  gu_dbug.c
  gu_fifo.c
  gu_lock_step.c
  gu_mem.c
  gu_mmh3.c
  gu_spooky.c
  gu_rand.c
  gu_threads.c
  gu_hexdump.c
  gu_to.c
  gu_utils.c
  gu_uuid.c
  gu_backtrace.c
  gu_limits.c
  gu_time.c
  gu_init.c
  )

# TODO: These should be eventually fixed:
# - Wno-unused-parameter
#
# Suppress -Wself-assign which may emit unwanted warnings when
# using byte swapping macros in way like k = gu_le64(k).
#
target_compile_options(galerautils
  PRIVATE
  -Wno-unused-parameter
  -Wno-declaration-after-statement
  -Wno-vla)

target_link_libraries(galerautils
  galerautils_log
  ${GALERAUTILS_HW_CRC32C_LIB}
  ${GALERA_SYSTEM_LIBS})

add_library(galerautilsxx STATIC
  gu_vlq.cpp
  gu_datetime.cpp
  gu_gtid.cpp
  gu_event_service.cpp
  gu_exception.cpp
  gu_hexdump.cpp
  gu_serialize.cpp
  gu_logger.cpp
  gu_regex.cpp
  gu_string_utils.cpp
  gu_uri.cpp
  gu_buffer.cpp
  gu_utils++.cpp
  gu_config.cpp
  gu_fdesc.cpp
  gu_mmap.cpp
  gu_alloc.cpp
  gu_rset.cpp
  gu_resolver.cpp
  gu_histogram.cpp
  gu_signals.cpp
  gu_stats.cpp
  gu_asio.cpp
  gu_asio_datagram.cpp
  gu_asio_stream_engine.cpp
  gu_asio_stream_react.cpp
  gu_debug_sync.cpp
  gu_thread.cpp
  gu_uuid.cpp
  )

# TODO: Warnings should be fixed.
target_compile_options(galerautilsxx
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter)

target_link_libraries(galerautilsxx galerautils ${GALERA_SSL_LIBS})

=== galerautils/tests/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

#
# C galerautils tests.
#

add_executable(gu_tests
  gu_tests.c
  gu_crc32c_test.c
  gu_mem_test.c
  gu_bswap_test.c
  gu_fnv_test.c
  gu_mmh3_test.c
  gu_spooky_test.c
  gu_hash_test.c
  gu_time_test.c
  gu_fifo_test.c
  gu_uuid_test.c
  gu_dbug_test.c
  gu_lock_step_test.c
  gu_str_test.c
  gu_utils_test.c
  )

# TODO: These should be eventually fixed.
# - Wno-unused-parameter
#
# Suppress -Wself-assign which may emit unwanted warnings when
# using byte swapping macros in way like k = gu_le64(k).
#
target_compile_options(gu_tests
  PRIVATE
  -Wno-unused-parameter
  -Wno-declaration-after-statement
  -Wno-vla
  )

target_link_libraries(gu_tests galerautils ${GALERA_UNIT_TEST_LIBS})

add_test(
  NAME gu_tests
  COMMAND gu_tests
  )

#
# C++ galerautils tests.
#
add_executable(gu_tests++
  gu_atomic_test.cpp
  gu_gtid_test.cpp
  gu_vector_test.cpp
  gu_string_test.cpp
  gu_vlq_test.cpp
  gu_digest_test.cpp
  gu_mem_pool_test.cpp
  gu_alloc_test.cpp
  gu_rset_test.cpp
  gu_utils_test++.cpp
  gu_string_utils_test.cpp
  gu_uri_test.cpp
  gu_config_test.cpp
  gu_net_test.cpp
  gu_datetime_test.cpp
  gu_histogram_test.cpp
  gu_stats_test.cpp
  gu_thread_test.cpp
  gu_asio_test.cpp
  gu_deqmap_test.cpp
  gu_progress_test.cpp
  gu_tests++.cpp
  )

target_compile_definitions(gu_tests++
  PRIVATE
  -DGU_ASIO_TEST_CERT_DIR="${CMAKE_CURRENT_BINARY_DIR}/certs")

# TODO: These should be eventually fixed.
target_compile_options(gu_tests++
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

target_link_libraries(gu_tests++
  galerautilsxx
  ${GALERA_UNIT_TEST_LIBS}
  )

add_test(
  NAME gu_tests++
  COMMAND gu_tests++
  )
#
# Deqmap micro benchmark.
#

add_executable(deqmap_bench deqmap_bench.cpp)

target_compile_options(deqmap_bench
  PRIVATE
  -Wno-conversion)

target_link_libraries(deqmap_bench galerautilsxx rt)

#
# CRC32C micro benchmark.
#
add_executable(crc32c_bench crc32c_bench.cpp)

target_compile_options(crc32c_bench
  PRIVATE
  -Wno-conversion)

target_link_libraries(crc32c_bench galerautilsxx)

#
# Hash implementation micro benchmark.
#

add_executable(avalanche avalanche.c)

target_compile_options(avalanche
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  -Wno-declaration-after-statement
  -Wno-vla)

target_link_libraries(avalanche galerautils)

#
# Test for old TO monitor implementation, should be removed once all of the
# code which uses gu_to module has been removed.
#
add_executable(gu_to_test gu_to_test.c)

target_link_libraries(gu_to_test galerautils)

target_compile_options(gu_to_test
  PRIVATE
  -Wno-conversion
  -Wno-declaration-after-statement
  -Wno-vla)

=== gcomm/src/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

add_library(gcomm STATIC
  asio_protonet.cpp
  asio_tcp.cpp
  asio_udp.cpp
  conf.cpp
  defaults.cpp
  datagram.cpp
  evs_consensus.cpp
  evs_input_map2.cpp
  evs_message2.cpp
  evs_node.cpp
  evs_proto.cpp
  gmcast.cpp
  gmcast_proto.cpp
  pc.cpp
  pc_proto.cpp
  protonet.cpp
  protostack.cpp
  transport.cpp
  uuid.cpp
  view.cpp
  socket.cpp
  )

# TODO: Fix these.
target_compile_options(gcomm
  PRIVATE
  -Wno-unused-parameter
  -Wno-conversion
  -Wno-overloaded-virtual
  )

target_link_libraries(gcomm galerautilsxx)

=== wsrep/tests/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

#
# Note: Files under ../src are inside wsrep-API submodule, so
# these tests won't compile unless the submodule has been
# initialized/updated.
#

add_executable(wsrep_test
  wsrep_loader_test.c
  ../src/wsrep_loader.c
  ../src/wsrep_dummy.c)
target_compile_definitions(wsrep_test
  PRIVATE
  -DWSREP_PROVIDER="${PROJECT_BINARY_DIR}/libgalera_smm.so"
  -DGALERA_VERSION="${GALERA_VERSION}"
  -DGALERA_GIT_REVISION="${GALERA_GIT_REVISION}")
target_link_libraries(wsrep_test dl)
add_test(NAME wsrep_test COMMAND wsrep_test)

=== gcs/src/unit_tests/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

add_executable(gcs_tests
  gcs_tests.cpp
  gcs_test_utils.cpp
  gcs_act_cchange_test.cpp
  ../gcs_act_cchange.cpp
  gcs_fifo_test.cpp
  ../gcs_fifo_lite.cpp
  gcs_sm_test.cpp
  ../gcs_sm.cpp
  gcs_comp_test.cpp
  ../gcs_comp_msg.cpp
  gcs_state_msg_test.cpp
  ../gcs_state_msg.cpp
  gcs_backend_test.cpp
  ../gcs_backend.cpp
  gcs_proto_test.cpp
  ../gcs_act_proto.cpp
  gcs_defrag_test.cpp
  ../gcs_defrag.cpp
  gcs_node_test.cpp
  ../gcs_node.cpp
  gcs_group_test.cpp
  gcs_memb_test.cpp
  ../gcs_group.cpp
  gcs_core_test.cpp
  ../gcs_code_msg.cpp
  ../gcs_core.cpp
  ../gcs_dummy.cpp
  ../gcs_msg_type.cpp
  ../gcs.cpp
  ../gcs_params.cpp
  gcs_fc_test.cpp
  ../gcs_fc.cpp
  ../gcs_error.cpp
  )

target_compile_definitions(gcs_tests
  PRIVATE
  -DGALERA_LOG_H_ENABLE_CXX
  -DGCS_CORE_TESTING
  -DGCS_DUMMY_TESTING
  )
if (GALERA_NONDETERMINISTIC_TESTS)
  target_compile_definitions(gcs_tests
    PRIVATE
    -DGCS_ALLOW_GH74
    )
endif()

# TODO: Fix.
target_compile_options(gcs_tests
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  -Wno-vla
  )

target_link_libraries(gcs_tests
  gcache
  ${GALERA_UNIT_TEST_LIBS}
  )

add_test(
  NAME gcs_tests
  COMMAND gcs_tests
  )

=== debian/changelog ===
galera-4 (26.4.23-0+deb12u1) bookworm; urgency=medium

  * New upstream release 26.4.23. Includes multiple bug fixes, see
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.23.txt
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.22.txt
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.21.txt
  * New upstream release fixes garbd's -w/WORK_DIR parameter (Closes: #1088076)

 -- Otto Kekäläinen <otto@debian.org>  Tue, 26 Aug 2025 14:47:38 -0700

galera-4 (26.4.20-0+deb12u1) bookworm; urgency=medium

  * New upstream release 26.4.20. Includes multiple bug fixes, see
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.20.txt
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.19.txt
  * Adopt gbp.conf from 'debian/latest' but adopt it for 'debian/12-bookworm'

 -- Otto Kekäläinen <otto@debian.org>  Sat, 31 Aug 2024 00:26:53 -0700

galera-4 (26.4.18-0+deb12u1) bookworm; urgency=medium

  * Switch to upstream aware DEP-14 branch structure in gbp.conf
  * New upstream release 26.4.18. Includes multiple bug fixes, see
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.18.txt
  * For previous release details see
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.17.txt
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.16.txt
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.15.txt
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.14.txt
  * New upstream signing key 3D53839A70BC938B08CDD47F45460A518DA84635,
    verified from 26.4.17 release notes
  * New upstream release includes multiple Debian build and post-build test
    failure fixes:
    - Generate keys and certificates for SSL tests (Closes: #1053334)
    - Attempt to bind to UDP and skips tests if not available
      (Related: #1007954)
    - Fix 'uuid == WSREP_UUID_UNDEFINED' (Related: #970044)
    - Fix issues reported -Werror when compiling (Related: #970043)
    - Fix UBSAN issues (Closes: #1053183, Related: #970042)

 -- Otto Kekäläinen <otto@debian.org>  Sun, 21 Apr 2024 21:52:19 -0700

=== debian/control ===
Source: galera-4
Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: Otto Kekäläinen <otto@debian.org>
Section: database
Priority: optional
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends: check,
               cmake,
               debhelper-compat (= 12),
               libboost-dev,
               libboost-program-options-dev,
               libssl-dev
Homepage: https://www.galeracluster.com/
Vcs-Browser: https://salsa.debian.org/mariadb-team/galera-4
Vcs-Git: https://salsa.debian.org/mariadb-team/galera-4.git

Package: galera-4
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: garbd-2,
           garbd-3,
           garbd2,
           garbd3,
           percona-galera-3,
           percona-galera-4,
           percona-xtradb-cluster-galera,
           percona-xtradb-cluster-galera-2.x,
           percona-xtradb-cluster-galera-3.x,
           percona-xtradb-cluster-galera-4.x,
           percona-xtradb-cluster-garbd-2.x,
           percona-xtradb-cluster-garbd-3.x
Provides: galera4,
          percona-xtradb-cluster-galera-26,
          wsrep
Breaks: galera-3 (<< 26.4)
Replaces: galera-3 (<< 26.4)
Description: Replication framework for transactional applications
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see https://github.com/codership/wsrep-API. For a description
 of Galera replication engine see http://galeracluster.com.
 .
 This package contains the Galera library/plugin.

Package: galera-arbitrator-4
Architecture: any
Conflicts: galera-arbitrator-3,
           garbd-2,
           garbd2,
           percona-galera-arbitrator-3,
           percona-galera-arbitrator-4,
           percona-xtradb-cluster-garbd-2.x
Breaks: percona-xtradb-cluster-galera-2.x
Replaces: percona-xtradb-cluster-galera-2.x
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Galera arbitrator daemon
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see https://github.com/codership/wsrep-API. For a description
 of Galera replication engine see http://galeracluster.com.
 .
 This package contains the Galera arbitrator daemon (garbd).

=== debian/rules ===
#!/usr/bin/make -f

# Enable Debian Hardening
# https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
# Include all defaults, including buildflags.mk
include /usr/share/dpkg/default.mk

# Set unit test timeout multiplier to make slow tests
# pass on loaded builders.
export CK_TIMEOUT_MULTIPLIER=5

override_dh_auto_test:
	dh_auto_test -O--no-parallel -- ARGS=--output-on-failure

# Start earlier than MySQL which has value 19
override_dh_installinit-arch:
	dh_installinit -n --name=garb -- defaults 18 22

override_dh_installsystemd:
	dh_installsystemd --name=garb

%:
	dh $@

=== debian/tests/control ===
Tests: smoke
Depends: galera-arbitrator-4
Restrictions: allow-stderr superficial

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://releases.galeracluster.com/galera-4/source galera-4-(.+).tar.gz

## galera-4 26.4.24

=== debian/changelog ===
galera-4 (26.4.24-1build1) resolute; urgency=medium

  * No-change rebuild for boost 1.90.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 04 Feb 2026 14:21:30 +0100

galera-4 (26.4.24-1) unstable; urgency=medium

  * New upstream release 26.4.24. Includes multiple bug fixes, see
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.24.txt
  * New upstream version includes the option to disable application level
    protocol check to allow migration from MySQL to MariaDB and other MariaDB
    compatibility improvements.

 -- Otto Kekäläinen <otto@debian.org>  Sat, 22 Nov 2025 19:33:46 -0800

galera-4 (26.4.23-1) unstable; urgency=medium

  * New upstream release 26.4.23. Includes multiple bug fixes, see
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-26.4.23.txt
  * Drop patch to fix garbd's -w/WORK_DIR parameter that is now applied upstream

 -- Otto Kekäläinen <otto@debian.org>  Tue, 12 Aug 2025 15:52:41 -0700
